;Przykładowy program POOL, możesz go używać,
;modyfikować i rozpowszechniać na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.pl

;Klasa żółwi rysujących linie:
; h0 - początkowy kierunek żółwia
; c  - kolor linii
to model :h0 :c
  to onsignalkrok ;funkcja obsługi sygnału "krok":
    "a += rnorm 2    ;mała, losowa zmiana kąta
    "v += rnorm 0.01 ;i długości kroku
    if abs :a > 30 ["a := 30 * sign :a]
    if :v > 10 ["v := 10]
    if :v < 0 ["v := 0]
    rt :a fd :v
  end

  let "v 3 ;początkowa długość kroku
  let "a 0 ;początkowy kąt obrotu
  (setpc :c 30)
  seth :h0
end

rerandom int timemilli ;inicjalizacja generatora liczb losowych
wrap hideturtle
setbg "black

"n := 1000
repeat :n [ ;utwórz :n żółwi klasy "model"
  let "h 360 * repcount / :n
  let "c 1000 * repcount / :n
  let "t (anewt $model :h :c) ;konstruktor asynchroniczny
]

shared "go  ;zmienna widoczna dla wszystkich żółwi
"go := true ;wartość "false" wstrzymuje rysowanie

"b := (button "Stop {20 10 60 24} [
  "go := not :go
  ifelse :go [settext :b "Stop] [settext :b "|Go!|]
])

;niezależny żółw sterujący rysowaniem
; - #first może swobodnie obsługiwać linię poleceń
"u := (anewt [forever [ifelse :go [signalw "krok] [wait 10]]])
